<template>
  <modal class="arcticmodal-container"
         height="auto"
         name="change-email-modal"
         :minWidth="300"
         :resizable="true"
         :adaptive="true"
         :reset="true"
         :delay="1"
         @opened="focusNewOpen"
         @closed="closeModalWindow"
         @before-open="$helpers.noscroll(true)"
         @before-close="$helpers.noscroll(false)"
  >

    <div>
      <div class="container m-header">
        <div class="box-modal_close arcticmodal-close" @click="closeModalWindow"></div>
        <div class="row">
          <div class="column">
            <h3>Изменение email</h3>
          </div>
        </div>
      </div>
      <div class="container" v-show="hideInput">
        <div class="row">
          <div class="column">
            <label for="new-email">Введите новый адрес электронной почты:</label>
            <input type="email"
                   name="email"
                   ref="newEmail"
                   id="new-email"
                   v-validate="'required|latin|min:4|max:50|email'"
                   v-model="newEmail"
                   :guide="true"
                   @keyup="checkEmail"
                   :keepCharPositions="true"
                   autocomplete="off"
                   :class="{error:showErr}"
            />
            <validate-message>
              {{err}}
            </validate-message>
          </div>
        </div>
      </div>
      <div class="center" v-show="hideButton">
        <button @click="changeEmail" :disabled="loading" :class="{button_loading: loading}">изменить</button>
      </div>
      <div class="container" v-show="!hideInput">
        <success-message></success-message>
      </div>
    </div>
  </modal>
</template>

<script>
  import backendApi from '@/utils/backend-api'
  import SuccessMessage from '@/components/AuxiliaryWindows/SuccessMessage'
  import {errorChangeEmail} from '@/utils/error/change-email'

  const clearData = () => {
    return {
      newEmail: '',
      hideInput: true,
      hideButton: false,
      showErr: false,
      err: '',
      loading: false,
    }
  }
  export default {
    components: {
      SuccessMessage
    },
    data: clearData,
    methods: {
      checkEmail () {
        this.$validator.validateAll().then((isEmail) => {
          if (isEmail) {
            this.hideButton = true
          } else {
            this.hideButton = false
            this.err = ''
            this.showErr = false
          }
        })
      },
      async changeEmail () {
        this.loading = true
        await this.$backend.api.user.email.edit(this.newEmail)
          .then(() => {
            //emailWithRestoreLinkSuccessfullySend
            this.$store.commit('CALL_SUCCESS_WINDOW', `На указанный адрес ${this.newEmail} отправлено письмо cо ссылкой на подтверждение`)
            this.$toastr.success(`На указанный адрес ${this.newEmail} отправлено письмо cо ссылкой на подтверждение`, 'Успешно')
            // this.$store.state.user.messageAuxiliaryWindows.cross = false
            this.hideInput = false
            this.hideButton = false
            window.wbEvent.send('CLIENT_CHANGE_EMAIL_SUCCESS')
            setTimeout(() => {
              this.closeModalWindow()
            }, 5000)
          })
          .catch(e => {
            this.err = errorChangeEmail(e.errors[0].code)
            this.$toastr.error(this.err, 'Ошибка')
            this.showErr = true
          })
          .finally(() => {
            this.loading = false
          })
      },
      focusNewOpen () {
        this.$nextTick(() => {
          this.$refs.newEmail.focus()
        })
      },
      closeModalWindow () {
        this.$modal.hide('change-email-modal')
        Object.assign(this.$data, clearData())
      }
    }
  }
</script>

<style scoped lang="scss">
  .box-modal {
    margin: 0
  }

  .v--modal-overlay .v--modal-box {
    border-radius: 10px
  }

  .tabs__content {
    display: block;
  }

  .content-block .white-block h3 {
    margin: 0;
  }

  .container {
    padding-bottom: 0 !important;
  }

  .m-header {
    padding-bottom: 30px !important
  }

  .close-modal-message {
    display: none !important;
  }
</style>
